Issue with require and require_relative with symlinked directories

06/28/2017 07:41 PM - fidothe (Matt Patterson)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.4.1p111 (2017-03-22 revision

58053) [x86_64-darwin16]

Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:

UNKNOWN

Description

Symlinked directories cause an issue with require_relative where libraries loaded from a symlinked path (e.g. in a typical Capistrano /

Bundler deployment) can be double-loaded.

Reproduce process:

1. Clone git repo from https://github.com/fidothe/symlink-require

2. Run use-symlink.rb script:

$ ruby use-symlink.rb

 Expected result: No warning from double-loading of constants issued.

Actual result: double-loading of file causing already-initialised constant warning.

In the example I linked above, target.rb uses require_relative to load dependent.rb.

When the example also requires dependent.rb the file is double-loaded and we see a warning about already-initialized constant.

The problem is that when require in use-symlink.rb (line 7) checks the set of loaded files it uses an absolute path containing the

symlink (since that is what was added to $LOAD_PATH), but when require_relative in target.rb is called, it uses an absolute path

containing target of the symlink, causing the double-load.

Is this discrepancy intended behaviour on Ruby's part?

Related issues:

Is duplicate of Ruby - Bug #10222: require_relative and require should be com... Closed

History

#1 - 06/28/2017 08:57 PM - rrosenblum (Ryan Rosenblum)

rspec-duplicate-require shows that this behavior has been around for at least 4 years. More recent discussions of this have been going on in prawn

and pdf-core.

#2 - 06/29/2017 02:03 AM - shyouhei (Shyouhei Urabe)

I guess this is a dup of #10222.

#3 - 06/29/2017 09:18 AM - fidothe (Matt Patterson)

shyouhei (Shyouhei Urabe) wrote:

I guess this is a dup of #10222.

 It is, sorry for not finding that when I looked for existing issues related to this.

#4 - 06/24/2019 06:39 PM - jeremyevans0 (Jeremy Evans)

- Is duplicate of Bug #10222: require_relative and require should be compatible with each other when symlinks are used added

#5 - 06/24/2019 06:39 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Open to Closed
